*
*  X2JSTFIL.PRG
*  Returns just the file name with or without extension
*  from a fully-qualified path plus file name
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*  Copyright (c) 1996  (Public Domain) Drew Speedie
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  22110
*                      703-369-1759
*  Author:  Drew Speedie
*
*  In _WINDOWS
*    uses FOXTOOLS.FLL/justfname()
*  In _DOS
*    does the work here 
*
*
*  Parameters
*    tcFileName (R) Path+Filename String to be parsed
*    tlNoExt    (O) Strip the extension?
*
*
*  USAGE:
*
*  ? x2jstfil(sys(2019))      &&& "CONFIG.FP" or "CONFIG.FPW", etc.
*  
*  ? x2jstfil(sys(2019),.t.)  &&& "CONFIG"
*
parameters tcFileName, tlNoExt
private lcRetVal, ;
        lnSlashPos, ;
        lnNameLen
lcRetVal = ""
DO CASE
  CASE _windows
    IF !"FOXTOOLS"$set("LIBRARY")
      IF file("FOXTOOLS.FLL")
        * somewhere in the path: 
        set library to FOXTOOLS.FLL additive
       ELSE 
        * in the FoxPro startup directory: 
        set library to sys(2004) + "foxtools.fll" additive
      ENDIF
    ENDIF
    lcRetVal = upper(justfname(tcFileName))
  OTHERWISE
    lnSlashPos = rat("\",tcFileName)
    IF lnSlashPos > 0
      lnNameLen  = len(tcFileName) - lnSlashPos
      lcRetVal = right(tcFileName, lnNameLen)
     ELSE
      lnColonPos = rat(":",tcFileName)
      IF lnColonPos > 0
        lnNameLen  = len(tcFileName) - lnColonPos
        lcRetVal   = right(tcFileName,lnNameLen)
      ENDIF
    ENDIF
ENDCASE 
IF tlNoExt
  IF "." $ lcRetVal
    lcRetval = left(lcRetVal,at(".",lcRetVal)-1)
  ENDIF
ENDIF

return lcRetVal




PROCEDURE keywords
* MISCELLANEOUS 
return