*
*  X3FWMAIN.PRG
*  Main calling program for MaxTech, Inc. 
*  Visual FoxPro applications
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*  Copyright (c) 1996  (Public Domain) Drew Speedie
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  22110
*                      703-369-1759
*  Author:  Drew Speedie
*           With help, input, ideas from:
*             Tom DeMay
*             Ed Lennon
*
*
**************************
*  Version 1.3  5/7/96
**************************
*  
*  The following is a list of enhancements made to the framework 
*  since version 1.00.  Retrofitting instructions refer to
*  modifications you must make to existing applications to keep
*  them in synch with the framework.
*
*  WHEN RETROFITTING:
*  Please note that when/if you are retrofitting changes to existing
*  code/classes in previous versions of this framework, you should
*  work from the bottom to the top of the list of items in the 
*  following lists of revisions/enhancements.  This is because
*  the revisions/enhancements lists are in the order they were
*  added, from latest to earliest 
*
*****************************************************
*
*  LEVEL 1
*
*****************************************************
*  Version 1.3 ENHANCEMENTS (Level 1)
*    and any revisions required from Version 1.22
*  5/7/96
*****************************************************
*  - Enhancement:  Rearranged the code in X3FW.VCX/frmData.Init()
*      to make it easier to subclass.  Added 2 new methods to
*      X3FW.VCX/frmData:  
*        SetDatabaseToMainAliasDBC()
*        SetInitialMainAliasRecno()
*    No retrofitting required because the code is the same, just
*      split out into separate methods.
*  - Bug fix:  Fixed the bug resulting in no "linked" toolbar
*      when multiple instances of a form were instantiated, each
*      linked to the same toolbar.  All the "linked" toolbar
*      logic was revised (simplified), involving the following:
*        X3FW.VCX/cusForms.DoForm()
*                         .DeleteInstance()
*                         .ToolbarCheckLinkedForm()
*        X3FW.VCX/cusFormInstance.Destroy()
*                                .Init()
*                                .icFormLinkedToolbar (new property)
*    No retrofitting required, unless you've already subclassed
*      and modified the above to fix the problem
*  - Enhancement:  Added support for specifying the DockPosition
*      of any specified icLinkedToolbar for frmBase-derived forms.
*      X3FW.VCX/frmBase
*        new property inLinkedToolbarInitialDockPosition for
*          specifying the initial dock position.  Defaults to
*          docked at the top
*      X3FW.VCX/cusForms.DoForm()
*        added code to Dock() any linked toolbar in the
*           location indicated in inLinkedToolbarInitialDockPosition
*    No retrofitting required unless you subclassed to provide
*      this functionality, in which case you might consider removing
*      your stuff and use this feature instead        
*  - Enhancement:  Added new behaviors to 
*      X3FW.VCX/frmReportDestination:
*        - Added the ability to designate the initally-selected
*          option, in case you want to default to "Printer" 
*        - Added the ability to pass a form title (caption)
*    No retrofitting required 
*  - Bug Fix:  Set BackStyle = 0 Transparent for OptionButtons3-10
*      of X3FW.VCX/opgBase
*    No retrofitting required
*  - Enhancement:  Added explicit SET DATABASE TO code before each
*      TABLEUPDATE() in X3FW.VCX/frmData.UpdateBuffers() to remedy
*      the occasional problem of VFP not being able to locate 
*      stored procedures in the corresponding database, usually
*      as a result of code in the RI Builder-generated referential
*      integrity code
*    No retrofitting required
*  - Bug fix:  Fixed the reference to "TOOLBAR" in 
*      X3FW.VCX/cusForms.DoForm() to be case-insensitive
*    No retrofitting required
*  - Bug fix:  Added code to 
*      X3FWFRM.VCX/frmDEGridNav2Pages.pgfPageRefresh1.Page2.Refresh()
*      to properly call THISFORM.ShellRequeryMainViewAlias() the
*      first time any page >2 is Activated, rather than each time.
*      This behavior was only noticeable in prior versions when
*      using frmDEGridNav2Pages with more than 2 pages on the 
*      pageframe.  zReadMe has been updated to accurately describe
*      Page.Activate() and Page.Refresh() code that must be added
*      to pages >2 added to the pageframe in instances/subclasses.
*    No retrofitting required unless you had 
*      1- existing forms based on X3FWFRM.VCX/frmDEGridNav2Pages
*         that had more than 2 pages in the pageframe
*      2- you had to add code to prevent a call to 
*         THISFORM.ShellRequeryMainViewAlias() each time a page
*         was Activated the first time for each grid row when in
*         edit mode
*  - Enhancement:  X3GENPK.PRG 
*      Modified the code to use the INDBC() function for faster
*        checking for a valid TableName in the specified database
*      Added code to TABLEREVERT() the REPLACE if X3GENPK is
*        unsuccessful
*      Added functionality so X3GENPK returns either numeric values
*      (for Integer data-type PKs) OR character values (as in 
*      previous versions).
*    No retrofitting required
*  - Enhancment:  Added (in X3FWDATA.PRG) a default APPINFO record 
*      for "SetPathProd" and changed the existing "SetPath" record 
*      to "SetPathDev".  This allows more control over the SET PATH,
*      and both records are checked in the updated
*      X3FW.VCX/ctrApp.SetupPPCLP() method.  Note that neither has
*      any effect on SET PATH unless populated, in which case they
*      OVERWRITE/REPLACE any existing SET PATH path.
*    Retrofitting requires changing your existing 
*      APPINFO.App_ItemPK="SetPath" to "SetPathDev" and adding a record
*      for APPINFO.App_ItemPK="SetPathProd"
*  - Enhancement:  Added code to X3FW.VCX/ctrApp.DevToolbarInstall()
*      to add the Developer's Toolbar to the menu if it exists but
*      isn't on the menu.  Also un-Protected DevToolBarInstall() method.
*    No retrofitting required
*  - Enhancement:  Added a parameter to X3FW.CusMenu.DefineBar()
*      method to allow passing a SKIP FOR condition as a character
*      string.
*    No retrofitting required unless you had code to do it manually
*      and want to use this new parameter instead.
*  - Bug Fix:  Un-Protected X3FW.VCX/cusMenu.InstallMenu() method.
*    No retrofitting required
*  - Bug Fix:  Added missing alias to an EOF() call in 
*      X3FW.VCX/frmData.UpdateBuffers() that caused an "End of
*      file encountered" error on ROLLBACK (in certain situations).
*  - Bug Fix:  Added missing call in X3FWCTRL.VCX/tmrBase.Init()
*      to THIS.ShellAdditionalInit().
*    No retrofitting required.
*  - Bug Fix:  Fixed bug that resulted in a linked toolbar remaining
*      visible when the linked form is Release()d and there are 
*      other extant forms that are linked to the same toolbar and 
*      the next form in the Activation stack is not one linked to
*      that toolbar.  The fix added a line of code to 
*      X3FW.VCX/cusForms/DeleteInstance().
*    No retrofitting required.
*  - Modification:  Renamed X3FW.VCX/frmData.SetFilterRelation() to
*      SetFilter().  Also added a separate SetRelation() method.
*    No Retrofitting required unless you have existing forms that
*      inherit from frmData and have custom SetFilterRelation() code.
*  - Enhancement:  Added code to X3FW.VCX/frmData.UpdateBuffers()
*      to post buffers for the main view/table alias before any
*      other buffered data so that parent information is 
*      available for rules in child/related tables.
*    No retrofitting required.
*  - Enhancement:  Added code to SET MARK OF BAR on the Window menu
*      to match the current active form.  
*        X3FW/cusMenu.SetMarkOfBar() new method
*                    .AddWindowMenuItem() updated 
*                    .DoesPopupExist() updated
*        X3FW/frmBase.Activate() updated 
*    No retrofitting required
*  - Enhancement:  Added 2 properties to X3FW.VCX/cusUser:
*        icPKSeekPrefix
*        icUsersTablePKTagName
*      to make it easy to use oUser with a USERS table whose PK is
*      comprised of a concatenation of fields.  Both new properties
*      are used in the revised oUser.LocateUserPK(), and icPKSeekPrefix
*      is used in X3FW.VCX/frmLogin.CustomPasswordValid().
*    No retrofitting required, but if you have existing code that uses
*      a concatenated PK in the USERS table, you might be able to 
*      simplify what you already have.
*  - Enhancement:  Added code to X3FW.VCX/frmData.Init() so that if
*      an initial value is set to a character string but no index tag
*      is set, we'll at least try the SEEK() with any available
*      Primary Key
*    No retrofitting required.
*  - Bug Fix:  X3FW.VCX/frmData.RemoteRefresh() executed the DBF()
*      function when the passed alias could be closed, resulting in
*      a crash
*    No retrofitting required.
*  - Modification:  Moved the When() code to the GotFocus() for all
*      the Text1 textboxes in columns of X3FW.VCX/grdBase.
*    No retrofitting required unless you had added other code to
*      either the When() or the GotFocus() to the above, in your
*      grdBase.
*  - Enhancement:  Added logic to X3FW.VCX/frmData.Init() to go EOF()
*      in THISFORM.icMainAlias if THISFORM.icInitialValue is a
*      negative number.
*    No retrofitting required unless you added your own code to do so,
*      in which case you can remove it and simply adjust the
*      tuInitialValue parameter.
*  - Enhancement:  Added a level of abstraction in the timer hiearchy.
*      Moved most of the behaviors of the former X3FW.VCX/tmrBase to
*      the new subclass X3FW.VCX/tmrEatStackedEvents.
*    No retrofitting required unless you were using 
*      instances/subclasses of tmrBase, in which case you can get the
*      identical behavior by redefining your instances/subclasses to 
*      inherit from the new X3FW.VCX/tmrEatStackedEvents class instead
*      (which has been done to the tmrAppTimer contained in 
*      X3FW.VCX/ctrApp).
*  - Modification:  Removed X3FW.VCX/ctrApp.ilRuntime protected
*      property and added the code that was missing from
*      X3FW.VCX/ctrApp.Runtime(), which returns a logical value
*      indicating whether the app is running via the runtime support
*      library or from the Command Window.
*    No retrofitting required unless you had oApp.GetPProp("ilRunTime")
*      calls, which must be changed to oApp.Runtime().
*  - Bug Fix:  Modified code in X3FW.VCX/cusForms.RealActiveControl()
*      to bypass processing when a grid is the active control but it
*      has no records in it, in which case .ActiveColumn = 0
*    No retrofitting required.
*  - Enhancmenemt:  Added new method 
*      X3FW.VCX/grdBase.SetColumnControlSources() for use in creating
*      grid classes bound to data (as opposed to grid classes bound to
*      data at the .SCX/instance level).  We've encountered a VFP
*      infelicity that is solved by setting Grid.Column.ControlSource
*      in a method rather than in the Properties Sheet.  For more info,
*      see the above new method.
*    No retrofitting required, but you may want to move explicit
*      Properties Sheet ControlSource settings to this new method
*      where appropriate.
*  - Modification:  Removed X3FWTOOL.VCX from Level1
*    No retrofitting required.
*  - Enhancement:  Added IF..ENDIF to X3FWCTRL.VCX/cboDropDownBound
*      calls to THISFORM.BoundControlsInteractiveChange() to allow 
*      using subclasses that don't have a ControlSource set, and
*      therefore won't send the form into "EDIT" mode.  Once
*      accomplished, the same logic/code added to:
*         X3FWCTRL.VCX/chkBound
*         X3FWCTRL.VCX/opgBound
*         X3FWCTRL.VCX/txtBound
*    No retrofitting required.
*  - Feature:  Added new form class X3FW.VCX/frmReportDestination in
*      the non-data-modal form hierarchy.
*    No retrofitting required.
*  - Feature:  Added new library routine X3WRPFRM.PRG which is simply
*      a wrapper to make it easy to call modal .VCX-based forms and
*      return the same value you would get if they were .SCX-based
*      forms and you executed them via DO FORM .. TO <memvar>.  Added
*      one line of code to X3FW.VCX/frmBase.Unload()
*  - Modification:  Added an optional parameter to 
*      X3FW.VCX/pgfPageRefresh.Page2.Refresh() to allow using it to
*      call generic Page.Refresh() in subclasses that add
*      pages > Page2.
*    No retrofitting required.
*  - Modification:  Changed the default installation of Form.Icon to
*      any specified application .Icon installation from 
*        X3FW.VCX/cusForms.DoForm()
*      to
*        X3FW.VCX/frmBase.Init()
*      including code to suppress the default FoxHead Icon if neither
*      the form nor the application specify an Icon.
*    No retrofitting required
*  - Modification:  Added code at the beginning of X3FWMAIN.PRG to
*      suppress the default FoxHead Icon until oApp installs any
*      application-specific icon.
*
*****************************************************
*  Version 1.22 ENHANCEMENTS (Level 1)
*    and any revisions required from Version 1.21
*  3/11/96
*****************************************************
*  - Enhancement:  Changed xxSYSTEM.DBF/APPINFO from a single-row table
*      to a multi-row table to make it easier to maintain and add new
*      application-specific rows.  Changes made to:
*        X3FWDATA.PRG
*          Modify the creation/population of APPINFO
*        X3FW.VCX/ctrApp
*          Modify existing THIS.GetAppInfo() calls
*            to update the passed parameter
*          Modify THIS.GetAppInfo()
*        X3FW.VCX/cusForms
*          Modify existing oApp.GetAppInfo() calls
*            to update the passed parameter
*        X3FW.VCX/cusUser
*          Modify existing oApp.GetAppInfo() calls
*            to update the passed parameter
*        X3CNVCHR.PRG
*          New library routine to convert character
*          strings, called by X3FW.VCX/ctrApp.GetAppInfo()
*    Retrofitting requires converting any existing APPINFO table as
*      follows and then adding rows to APPINFO corresponding to any
*      added fields in the old APPINFO format:
*        clear all
*        close all
*        open data ?? exclusive
*        use APPINFO exclusive
*        scatter memvar memo
*        use 
*        remove table APPINFO delete
*        create table ??SYSTEM name APPINFO ;
*             (App_ItemPK          C(20), ;
*              App_ItemDataType    C(1), ;
*              App_ItemValue       C(100),; 
*              App_ItemDescription M(4))
*        alter table APPINFO add primary key upper(App_ItemPK) tag App_ItemPK 
*        =dbsetprop("APPINFO",                     "TABLE", "Comment", "Application-level information") 
*        =dbsetprop("APPINFO.App_ItemPK",          "FIELD", "Comment", "Application setup/configuration item (Primary Key)")
*        =dbsetprop("APPINFO.App_ItemDataType",    "FIELD", "Comment", "Data type for App_Item (C,N,L,D,T)")
*        =dbsetprop("APPINFO.App_ItemValue",       "FIELD", "Comment", "App_Item value")
*        =dbsetprop("APPINFO.App_ItemDescription", "FIELD", "Comment", "Description of App_Item")
*        m.App_ItemPK          = "DevModeExpr"
*        m.App_ItemDataType    = "E"
*        m.App_ItemValue       = [getenv("FPDEV")="ON"]
*        m.App_ItemDescription = space(0)
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "SetProcedure" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_SetProcedureFiles
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "SetClasslib" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_SetClasslibFiles
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "SetLibrary" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_SetLibraryFiles
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "SetPath" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_SetPath
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "Title" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_Title
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "IconFile" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_IconFile
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "ScreenWallpaperFile" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_ScreenWallpaperFile
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "UserLoginFormClass" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_UserLoginFormClass
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "DevToolbarClass" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_DevToolbarClass
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "DevToolbarPad" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_DevToolbarPadPrompt
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "LoginControl"
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_LoginControl
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "AutoLoginUserID" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_AutoLoginUserID
*        insert into APPINFO from memvar
*        m.App_ItemPK          = "AutoLoginPassword" 
*        m.App_ItemDataType    = "C"
*        m.App_ItemValue       = m.App_AutoLoginPassword
*        insert into APPINFO from memvar
*        IF type("m.App_AppTimerInterval") = "N"
*          m.App_ItemPK          = "AppTimerInterval"
*          m.App_ItemDataType    = "N"
*          m.App_ItemValue       = alltrim(str(int(m.App_AppTimerInterval)))
*          insert into APPINFO from memvar
*        ENDIF
*        IF type("m.App_TimeoutSeconds") = "C"
*          m.App_ItemPK          = "TimeoutSeconds" 
*          m.App_ItemDataType    = "N"
*          m.App_ItemValue       = alltrim(str(int(m.App_TimeoutSeconds)))
*          insert into APPINFO from memvar
*        ENDIF
*        IF type("m.App_TimeoutType") = "C"
*          m.App_ItemPK          = "TimeoutType"
*          m.App_ItemDataType    = "C"
*          m.App_ItemValue       = m.App_TimeoutType
*          insert into APPINFO from memvar
*        ENDIF
*        clear all
*        close all
*
*  - Bug Fix:  When a form has a linked toolbar, the Window menu was
*      not being updated properly when forms were released.  Changes
*      made to 
*         X3FW.VCX/cusForms.DoForm()
*         X3FW.VCX/cusMenu.ReleaseWindowMenuItem()
*    No retrofitting required
*  - Bug Fix:  On Show()ing (via a selection on the Window menu) after
*      being minimized, forms weren't restoring to their previous
*      WindowState.  Change is to
*        X3FW.VCX/frmBase.Activate(), Show(), Resize(),
*      and the addition of new protected property .PreviousWindowState
*    No retrofitting required.
*  - Feature:  On instantiation, if a form's .Icon property is blank,
*      default .Icon to the application icon (if any).  Change made to
*      X3FW.VCX/cusForms.DoForm().
*    No retrofitting required
*  - Enhancement:  Added code to X3FWDATA.PRG to create the LV_USERS
*      local view.  
*    No retrofitting required.  However, if you modify your
*      application-specific USERS table, you'll have to apply those
*      updates to the LV_USERS view, too.
*    
*****************************************************
*  Version 1.21 ENHANCEMENTS (Level 1)
*    and any revisions required from Version 1.20
*  3/8/96
*****************************************************
*  - Feature:  Splash screen capabilities.
*    Retrofitting requires passing the new (optional) 8th lparameter
*      to X3FWMAIN -- see the lParameters listing below and the new
*      local procedure InstallSplashScreen
*  - Modification:  Renamed X3FW.VCX/frmDataDialog to frmDataModal.
*    No retrofitting required unless you have subclasses/forms of
*      frmDataDialog, in which case you need to change the ParentClass
*      property (the Class field in the .VCX) to "frmDataModal".
*  - Modification:  Added a new abstract form class 
*       X3FW.VCX/frmNonData, a subclass of frmBase.
*    No retrofitting required.
*    Renamed X3FW.VCX/frmNonDataDialog to X3FW.VCX/frmNonDataModal,
*      and redefined as a subclass of X3FW.VCX/frmNonData.  (required
*      a change to an explicit :: call in frmLogin)
*    Retrofitting requires changing the ParentClass property (Class
*      field in the .VCX) from "frmNonDataDialog" to "frmNonDataModal"
*      if you created classes/forms subclassed directly from
*      X3FW.VCX/frmNonDataDialog.
*  - Modification:  Added dummy methods GetMode() and 
*      BoundControlsInteractiveChange() to X3FW.VXC/frmData to prevent
*      errors when using Level 2 bound controls on forms from
*      X3FW.VCX/frmDataDialog.
*    No Retrofitting required.
*  - Modification:  Added a candidate key tag USERS.Usr_LanID to the
*      USERS table (done in X3FWDATA.PRG).
*    Retrofitting requires: 
*      clear all
*      close all
*      open database xxxxx exclusive
*      use USERS exclusive
*      index on Usr_LanID tag Usr_LanID candidate for !deleted()
*      clear all
*      close all
*
*****************************************************
*  Version 1.20 ENHANCEMENTS (Level 1)
*    and any revisions required from Version 1.10
*  2/27/96
*****************************************************
*  - Bug Fix:  Modified X3FW.VCX/cusForms.DoForm() to fix a bug with
*      the positioning of the oFormInstance object added to forms after
*      instantiation.  Caused a portion of the upper-left area of the
*      form to be "dead".
*    No retrofitting required unless you've subclassed DoForm(), in
*      which case add the WITH..ENDWITH code manipulating 
*      Height/Width/Top/Left properties.
*  - Enhancement:  Modified X3FW.VCX/ctrApp.Destroy() to improve the
*      cleanup process when running in any Command Window mode
*      (as oppposed to runtime).
*    Changes made to
*       ctrApp.Destroy()
*       ctrApp.Init()
*       ctrApp.SetupSets() 
*       ctrApp.ilRuntime (new protected property)
*       ctrApp.Runtime() (new exposed method)
*    No retrofitting required.
*  - Modification:  Modified X3GENPK/generate PK behavior, X3FWDATA.PRG
*      now requires a GENERATEPK the table name for the generate-PK
*      table in each database.  Also eliminated the third (optional
*      tcGENPKTableName) parameter received by X3GENPK.PRG.
*    Retrofitting requires:
*      Renaming existing ??GENPK tables to GENERATEPK
*          clear all
*          close all
*          open data xxxxx excl
*          rename table xxGENPK to GENERATEPK
*          clear all
*          close all          
*      Use of the new version of X3GENPK
*      Eliminating the 3rd parameter sent to any calls to X3GENPK()
*
*****************************************************
*  Version 1.10 ENHANCEMENTS (Level 1)
*    and any revisions required from Version 1.00
*  2/23/96
*****************************************************
*  - Feature:  Added timeout to the application
*    Retrofitting requires new xxSYSTEM.DBF/APPINFO fields:
*      App_AppTimerInterval I(4)  (default to 0)
*      App_TimeoutSeconds I(4)    (default to 0)
*      App_TimeoutType C(1)       (default to "N")
*        clear all
*        close all
*        open data xxxxx excl
*        alter table APPINFO ;
*            add column App_AppTimerInterval I(4)
*        alter table APPINFO ;
*            add column App_TimeoutSeconds I(4)
*        alter table APPINFO ;
*            add column App_TimeoutType C(1)
*        clear all
*        close all          
*      NOTE:  If you're upgrading directly from version 1.00 to  
*             version 1.22 or higher, you can skip this retrofit.
*  - Enhancement:  Improved action to update other extant forms on
*      saving modified form data.  Replaced 
*      X3FW.VCX/cusForms.RefreshSpecificForms() with 
*      .RefreshFormsOnUpdate()
*    No retrofitting required unless you've subclassed RefreshSpecificForms()
*  - Modification:  Changed X3FW.VCX/frmModal to
*      X3FW.VCX/frmNonDataDialog.
*    Retrofitting required to change any 
*      ParentClass = "frmModal" to "frmNonDataDialog"
*  - Modification:  Changed the way the initial menu is executed
*      in oMenu:
*      Changed X3FW.VCX/cusMenu.BeforeInstallMenu() to .BeforeInstallInitialMenu()
*      Changed X3FW.VCX/cusMenu.AfterInstallMenu() to .AfterInstallInitialMenu()
*      Changed X3FW.VCX/cusMenu.InstallMenu() to .InstallInitialMenu()
*    No retrofitting required unless you're currently using
*       BeforeInstallMenu() or AfterInstallMenu()
*  - Modification:  Added new X3FW.VCX/cusMenu.InstallMenu() to allow
*      executing any passed .MPR menu
*    No retrofitting required (see the above item)
*
*****************************************************
*****************************************************
*****************************************************
*****************************************************
*
*  LEVEL 2
*
*****************************************************
*  Version 1.3 ENHANCEMENTS (Level 2)
*    and any revisions required from Version 1.22
*  5/7/96
*****************************************************
*  - New Feature:  New class X3FWCTRL.VCX/cmdGetDir to allow
*      easy use and subclassing of the GETDIR() dialog.
*    No retrofitting required
*  - New Feature:  New class ctrGetDirAndFile of new .VCX
*      X3FWCTR.VCX (containers), provides a container of
*      one instance of X3FWCTRL.VCX/cmdGetDir and a textbox
*      to allow the user to specify a directory + file
*    No retrofitting required
*  - New Feature:  New class X3FWCTRL.VCX/cmdGetFile to allow
*      easy use and subclassing of the GETFILE() dialog
*    No retrofitting required
*  - New Feature:  New class X3FWCTR.VCX/ctrGetFile to allow
*      giving the user the GETFILE() dialog and displaying the
*      selected file
*    No retrofitting required
*  - New feature:  New class X3FWFRM.VCX/frmReportDestinationSPF,
*      subclasses X3FW.VCX/frmReportDestination to support
*      additional functionality for a TO FILE destination
*    No retrofitting required
*  - Bug fix:  Moved most of the X3FWGRD.VCX/cmdDEGridAdd.Click()
*      to X3FWGRD.VCX/grdDataEntry.AddRow(), and fixed a (harmless)
*      bug that resulted in the indicated 
*      grdDataEntry.inActiveColumnOnAdd not receiving focus on
*      Add.
*    No retrofitting required unless you've subclassed
*      X3FWGRD.VCX/cmdDEGridAdd.Click() code, in which case you'll
*      have to check out the code migration described above.
*  - Enhancement:  Added lots of new features to data-entry grids
*      and the forms that contain them:
*      - X3FWGRD.VCX/grdDataEntry grids "register" themselves
*        with the form that contains them
*      - X3FWFRM.VCX/frmDataEntry forms maintain an array property
*        of references to registered data-entry grids
*      - X3FWCTRL.VCX/cmdDataSave.Click() contains code calling
*        a new method to tell all form-registered data-entry grids
*        to execute their OnSave() code
*      - X3FWCTRL.VCX/cmdDataAdd.Click() contains code to 
*        tell all form-registered data-entry grids to requery()
*        themselves on Add
*      - X3FWGRD.VCX/grdDataEntry grids that are bound to the "child"
*        table in a one-to-many data-entry form know how to populate
*        their foreign key(s) to the "parent" table
*      - X3FWFRM.VCX/frmDataEntry forms handle add-on-the-fly
*        behavior better than they used to 
*      All this good stuff is accomplished by the following 
*      modifications:
*        X3FWFRM.VCX
*           frmDataEntry - new property iaDataEntryGrids holds object references to data-entry grids
*                        - new method RegisterDataEntryGrids to populate iaDataEntryGrids 
*                        - Init() code to requery views 
*                        - Destroy() code to set THIS.iaDataEntryGrids = .NULL.
*                        - new method UpdateFormOnNew
*                        - new UpdateFormOnDelete code (calls UpdateFormOnNew)
*                        - new UpdateFormOnCancel code
*                        - new UpdateAddOnTheFlyRecord method to store the PK of the last-added record to THISFORM.iuRetVal... in THISFORM.icAddOnTheFlyAlias situation
*         X3FWGRD.VCX
*           grdDataEntry - new property icParentAlias
*                        - new property icParentViewAlias
*                        - new property icFKFieldName
*                        - new property icParentPKFieldName
*                        - new property icGridItemExpression
*                        - new property ilRegisterWithForm
*                        - changed ShellOnSaveBeforeDeleteBlankRows() to OnSaveBeforeDeleteBlankRows()
*                        - changed ShellOnSaveAfterDeleteBlankRows() to OnSaveAfterDeleteBlankRows()
*                        - added default code to OnSaveAfterDeleteBlankRows() to populate PK and FK
*                        - added code to the end of Init() to register into THISFORM.iaDataEntryGrids array
*           cmdDEGridAdd - added Refresh() code
*                        - defaulted Enabled = .f.
*        cmdDEGridDelete - defaulted Enabled = .f.
*                        - fixed bug in Click() resulting in THIS.Enabled = .t.
*                          even after deleting the last row in the grid
*                        - modified the code that creates the default generic message
*         X3FW.VCX
*                grdBase - added THIS.SetinCurrentRecno() to THIS.Refresh()
*                        - added code to THIS.Refresh() to position the record pointer
*                          on the last record if eof(THIS.RecordSource)
*        X3FWCTRL.VCX
*            cmdDataFind - added default behavior to Click to find a value and
*                          call new THISFORM.UpdateFormOnNew() method
*                        - added new method DoTheFind() to call the Find Form
*          cmdDataCancel - Click() - fixed bugs...
*            cmdDataSave - Click() to save any/all DataEntryGrids
*             cmdDataAdd - Click() to requery data entry grids
*    Retrofitting requires:
*      - applying any X3FWGRD.VCX/grdDataEntry.ShellOnSaveBeforeDeleteBlankRows() 
*        to the new/replacement OnSaveBeforeDeleteBlankRows() method
*      - applying any X3FWGRD.VCX/grdDataEntry.ShellOnSaveAfterDeleteBlankRows() 
*        to OnSaveAfterDeleteBlankRows()
*      - making use of any of the new stuff
*      - if you have existing forms with X3FWGRD.VCX/grdDataEntry
*        grids that you don't want to use the new features (probably
*        because you're already handling this new stuff manually), 
*        you can easily do so by not using the new properties and
*        by disabling the auto-registration process by including
*        the following 2 lines of code at the end of the Init()
*        of any form inheriting from X3FWFRM.VCX/frmDataEntry: 
*          dimension THIS.iaDataEntryGrids[1]
*          THIS.iaDataEntryGrids = .NULL.
*      - test, test, test <g>
*  - Enhancement:  Added a new X3FWGRD.VCX/grdDataEntry.AlreadyInGrid()
*      method to allow easily checking whether or not an entered
*      value is already contained in the grid.
*    No retrofitting required
*  - Bug Fix:  X3BLDTXT.SCX textbox builder had a bogus reference
*      to loCurrentControl in the code that auto-sizes.
*    No retrofitting required
*  - Enhancement:  Added Read-Only capabilities to the combination of
*      X3FWFRM.VCX/frmMemoEdit
*      X3FWCTRL.VCX/cmdCallDataMemoEditForm
*    No retrofitting required, but if you need the ability to call
*      frmMemoEdit in Read-Only mode, you can now call it with the
*      new 4th parameter
*  - Bug Fix:  Added missing callback to X3FWCTRL.VCX/tmrGridPause.Init()
*    No retrofitting required.
*  - Modification:  Changed X3FWFRM.VCX/frmUserMaintenance
*      to use X3MANUCK() instead of X3ONFILE() for manual CK validation.
*    No retrofitting required.
*  - Bug Fix:  Added any defined SEEK prepend value to the called
*      picklist form in X3FWCTRL.VCX/txtPicklistValid.DoPicklistForm()
*    No retrofitting required, bug was only evident when using
*      concatenated PKs
*  - Bug Fix:  Fixed a typo in cmdDEGridDelete.Click() causing a
*      crash on the 2nd CASE statement
*    No retrofitting required
*  - Enhancement:  Added new property
*        X3FWFRM.VCX/frmDataEntry.icPKPrepend
*      plus code in 
*        X3FWFRM.VCX/frmDataEntry.GenAndPopPK()
*      to handle PK generation when the PK expression is a concatenation
*      of fields.
*    No retrofitting required unless you have existing forms that
*      manage concatenated PKs manually and you'd like to take 
*      advantage of the generic/automatic stuff here.
*  - Modification:  Changed the filename of X3FWTOOL.VCX/.VCT 
*      to X3TOOLS.VCX/.VCT and added some utility classes
*    Retrofitting requires updating the "DevToolbarClass" record of
*      your APPINFO table accordingly.
*  - Enhancement:  Updated X3SEEK.PRG to allow optionally excluding
*      buffered data from the SEEK().
*    No retrofitting required.
*  - Modification:  Updated code in X3ONFILE.PRG to correct deficiencies
*      in resetting the alias/database environment.
*    NOTE:  New program X3MANUCK.PRG is an improved program,
*           replacing X3ONFILE.PRG.  X3ONFILE.PRG has not been
*           removed from the X library for reasons of 
*           backward compatibility, but we recommend you use
*           X3MANUCK.PRG from now on.
*    No retrofitting required, unless you want to convert your
*      existing X3ONFILE() calls to X3MANUCK().
*  - Modification:  Changed the way parameters are received and 
*      processed in forms inheriting from 
*        X3FW/frmData tuInitialValue, tcFilter
*        X3FWFRM/frmDataEntry tlAddOneRecordOnly
*        X3FWPICK/frmPicklist tlNoAdd
*      See zReadMe for the lowest-level form classes
*        frmDEGridNav2Pages
*        frmDEGridNavNoPages
*        frmDEFindNav
*        frmPicklist
*      for the revised instructions.  For this modification, we got
*      rid of:
*        iuInitialValue
*        icFilter
*      and changed
*        ilAddOneRecordOnly/tlNoAdd 
*      to
*        icAddOnTheFlyAlias/tlNoAddButton
*      and eliminated the setting of the above properties in the
*      Init().  Now we pass the parameters up the inheritance 
*      hierarchy.
*    Retrofitting requires modifying your Init() code if you're
*      receiving any of the 3 parameters (see zReadMe of the 
*      appropriate class X3FWFRM.VCX/X3FWPICK.VCX class definition)
*  - Bug Fix:  X3FWFRM.VCX/frmDataEntry.RemoteRefresh() executed the
*      DBF() function when the passed alias could be closed, resulting
*      in a crash
*    No retrofitting required.
*  - Modification:  Moved the When() code to the GotFocus() method for
*      the following classes:
*        X3FWCTRL.VCX/chkBound
*        X3FWCTRL.VCX/edtBound
*        X3FWCTRL.VCX/txtBound
*    No retrofitting required unless you had added code to either the
*      When() or the GotFocus() of any of the above classes.
*  - Bug Fix:  Modified code in 
*      X3FWCTRL.VCX/txtPicklistValid.ProcessNewValue() to handle 
*      Grid.Column.ControlSource goofiness
*    No retrofitting required.
*  - Enhancement:  Added code to protect against attempting to change
*      the Name property of textboxes that are part of class
*      definitions in X3BLDTXT.SCX (the MaxTech textbox Builder.)
*      This enhancement uses the PEMSTATUS() function new to VFP 3.0b.
*  - Modification:  Moved the code that was in 
*      X3FWCTRL.VCX/cmdDataDelete.DoTheDelete() to the new 
*      X3FWFRM.VCX/frmDataEntry.DeleteAction() method.  Also added
*      LockScreen behavior to the entire delete process, in 
*      cmdDataDelete.Click()
*    No retrofitting required unless you had modified DoTheDelete() in
*      any instances or subclasses of cmdDataDelete.DoTheDelete().
*  - Enhancement:  Changed the default behavior when instantiating a
*      xxPKxxx picklist form and there are no records in the table 
*      providing the Grid.RecordSource.  The old behavior was to give
*      the user a message dialog telling them there are no valid items
*      and bailing out of the form.  The new behavior calls up the form
*      with no records and the <Select> button disabled, leaving
*      <Cancel> and <Add> (if you allow it) available.  Changes were
*      made to
*        X3FWPICK.VCX/frmPicklist.EmptyPicklist()
*          to remove all code and leave a comment
*        X3FWPICK.VCX/cmdPicklistOK.Refresh() to
*          handle setting Enabled based on EOF()
*          in the grid
*    No retrofitting required unless you want a different behavior
*      from EmptyPicklist()
*  - Enhancement:  Created 2 timer subclasses in X3FWCTRL.VCX, to
*      provide the generic functionality heretofore only available in
*      X3FWFRM.VCX/frmDEGridNavNoPages -- to do something (like refresh
*      controls) when the user pauses for the Interval on a specific
*      record.
*    No retrofitting required unless you added some explicit code to
*      the timer you inherited from X3FWFRM.VCX/frmDEGridNavNoPages
*      or if you modified the Grid.AfterRowColChange in 
*      X3FWFRM.VCX/frmDeGridNavNoPages to send explicit messages to the
*      timer.
*  - Enhancement:  migrated X3FWCTRL.VCX/cmdDataSave.GeneratePK() 
*      up to X3FWFRM.VCX/frmDataEntry, where it is renamed GenAndPopPK()
*      and further genericized to allow for more flexible PK generation.
*    No retrofitting required unless you have existing classes/instances
*      that made explicit calls to the old 
*      X3FWCTRL.VCX/cmdDataSave.GeneratePK(), in which case you need
*      to replace them with the appropriate THISFORM.GenAndPopPK() calls.
*  - Bug Fix:  Added some kludge code to X3FWFRM.VCX/frmUserMaintenance
*      to fix the sporadic problem of incomplete Form.Paint() on
*      instantiation.
*    No retrofitting required.
*
*****************************************************
*  Version 1.22 ENHANCEMENTS (Level 2)
*    and any revisions required from Version 1.21
*  3/11/96
*****************************************************
*  Enhancement:  Added EXTERNAL FILE references to MTMAIN.PRG/pmFakeOut
*    local procedure to pull .ICO and .BMP files into the .PJX.
*  No retrofitting required
*  Bug Fix:  Modified code in X3FWFRM.VCX/frmDEGridNav.Activate() to
*    not just override but callback to frmData::Activate() to 
*   'manually inherit' higher-level Activate() code
*  No retrofitting required
*
*****************************************************
*  Version 1.21 ENHANCEMENTS (Level 2)
*    and any revisions required from Version 1.20
*  3/8/96
*****************************************************
*  - Bug Fix:  Details page(s) of pgfPageRefresh1 in data-entry form
*      classes were not being properly remote-refreshed in certain
*      situations.  Change is in 
*         X3FWFRM.VCX/frmDataEntry.RemoteRefresh()
*    No retrofitting required
*  - Bug Fix:  Behavior was incorrect on Activate()ing a data-entry
*      form whose icMainTableAlias record is now deleted().  Change
*      is to X3FWFRM.VCX/frmDataEntry.CheckIfOnDeletedRecord()
*    No retrofitting required
*  - Modification:  Improved the behavior of <Cancel>ing and finding
*      that icMainTableAlias is now deleted().  Change is to 
*         X3FWCTRL.VCX/cmdDataCancel.Click()
*    No retrofitting required
*  - Modification:  As a result of the Level 1 rename (see above) of
*      X3FW.VCX/frmDataDialog to X3FW.VCX/frmDataModal:
*      Redefined X3FWFRM.VCX/frmReadOnlyInfo as a subclass of 
*        X3FW.VCX/frmDataModal.
*      Redefined X3FWPICK.VCX/frmPicklist as a subclass of 
*        X3FW.VCX/frmDataModal.
*    No retrofitting required.     
*  - Modification:  Redefined class X3FWFRM.VCX/frmStandby as a
*      subclass of the new (see Level 1 revisions) X3FW.VCX/frmNonData
*      class.
*    No retrofitting required.
*  - Feature:  Added form class X3FWFRM.VCX/frmUserMaintenance to make
*      it easy to create a xxDEUSR.SCX User Reference Maintenance
*      data-entry form.
*    No retrofitting required, but to actually use it, you'll need an
*      LV_USERS local view:
*      clear all
*      close all
*      open database xxxxx exclusive
*      CREATE SQL VIEW LV_USERS AS ;
*         SELECT * ;
*         FROM xxxxx!USERS ;
*         WHERE Users.usr_pk = ?lcUsr_PK
*      =DBSetProp( 'LV_USERS', 'View', 'UpdateType', 1 )
*      =DBSetProp( 'LV_USERS', 'View', 'WhereType', 3 )
*      =DBSetProp( 'LV_USERS', 'View', 'FetchMemo', .T. )
*      =DBSetProp( 'LV_USERS', 'View', 'SendUpdates', .T. )
*      =DBSetProp( 'LV_USERS', 'View', 'UseMemoSize', 255 )
*      =DBSetProp( 'LV_USERS', 'View', 'FetchSize', 100 )
*      =DBSetProp( 'LV_USERS', 'View', 'MaxRecords', -1 )
*      =DBSetProp( 'LV_USERS', 'View', 'Tables', 'xxxxx!users' )
*      =DBSetProp( 'LV_USERS.usr_pk', 'Field', 'KeyField', .T. )
*      =DBSetProp( 'LV_USERS.usr_pk', 'Field', 'Updatable', .T. )
*      =DBSetProp( 'LV_USERS.usr_pk', 'Field', 'UpdateName', 'xxxxx!users.usr_pk' )
*      clear all
*      close all
*    NOTE:  LV_USERS view is included in X3FWDATA.PRG
*           in version 1.22, so you may not need
*           to bother with this retrofit.
*  - Bug Fix:  Fixed bug in X3FWFRM.VCX/frmDataEntry.UpdateFormCaption()
*      that resulted in a blank form caption when running a data-entry
*      form receiving a filter condition parameter
*    No retrofitting required
*  - Bug Fix:  Fixed bug in 
*      X3FWCTRL.VCX/txtPicklistValid.InteractiveChange()
*      that resulted in embedded spaces being removed as data is
*      entered
*    No retrofitting required.
*  - Enhancement:  Reworked the default way SET FILTER is applied in
*      frmData::Init(), frmData::SetFilterRelation.
*       Removed:  frmData.ShellSetFilter()
*         Added:  frmData.icFilter
*      Replaced:  frmData.iuFilterValue with .icFilter
*    Retrofitting required only for data-entry forms that receive the
*      2nd tuFilterValue parameter and make use of it.  Forms in the
*      X3FW.VCX/frmData hierarchy are affected, primarily:
*         X3FWFRM.VCX/frmDEFindNav
*         X3FWFRM.VCX/frmDeGridNavNoPages
*         X3FWFRM.VCX/frmDeGridNav2Pages
*         X3FWPICK.VCX/frmPicklist
*      Any data-entry forms receiving the 2nd tuFilterValue need to
*        instead receive tcFilter parameter.     
*      The former tuFilterValue was used in the former .ShellSetFilter()
*        to manually SET the FILTER.  This enhancement receives the
*        entire filter expression in tcFilter and SETs it by default
*        in the new SetFilterRelation() method.
*    NOTE:  SetFilterRelation() is renamed SetFilter() in version 1.3
*  - Bug Fix:  Fixed bug in X3FWCTRL.VCX/txtPicklistValid when the
*      textbox is used in a grid column.  Before this fix, the
*      displayed .Value would revert on exiting the field via
*      {TAB}/{ENTER} if a valid value had been keyboarded in.
*    No retrofitting required
*
****************************************************
*  Version 1.20 ENHANCEMENTS (Level 2)
*    and any revisions required from Version 1.10
*  2/27/96
*****************************************************
*  - Bug Fix:  Fixed bug in X3FWCTRL.VCX/txtPicklistValid.  If an
*      invalid value was entered, firing the picklist, from which the
*      invalid value was added and then selected, then the newly-
*      added value wasn't registered as a field update and not saved.
*    No retrofitting required.
*  - Bug Fix:  Fixed bug in X3FWFRM.VCX/frmDEGridNavNoPages
*      When called in !THIS.ilAddOneRecordOnly mode, would generate an
*      error on attempting THIS.ShellRequeryMainViewAlias in Init()
*    No retrofitting required.
*
*****************************************************
*  Version 1.10 ENHANCEMENTS (Level 2)
*    and any revisions required from Version 1.00
*  2/23/96
*****************************************************
*  - Feature:  Incremental auto-fill added to 
*      X3FWCTRL.VCX/txtPicklistValid
*    No retrofitting required
*  - Enhancement:  Added properties to X3FWCTRL.VCX/txtPicklistValid
*      to control menu pad prompt and hotkey
*    No retrofitting required
*
*
*
*
*
*  COPYRIGHT NOTICE
*  ======================================================  
*  All source code and documentation contained in X3FWMAIN and its 
*  subsequent "application framework" were developed at MaxTech, Inc.
*  and have been placed into the public domain.  You may use, modify,
*  copy, distribute, and demonstrate any source code, example programs,
*  or documentation contained in X3FWMAIN and its subsequent
*  "application framework" supporting files freely without copyright
*  protection.  All files contained in X3FWMAIN and its subsequent 
*  "application framework" supporting files are distributed in the hope
*  that it will be useful, but WITHOUT ANY WARRANTY; without even the
*  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
*  PURPOSE.  In no event shall its authors, contributors, or
*  distributors be liable for any damages.
*
*  
*  REQUIRED ELEMENTS:
*  ======================================================  
*
*  VFP version 3.0 or higher is required.  Future revisions will
*  require VFP version 3.0b as we plan to incorporate the use of
*  GETPEM() and PEMSTATUS() functions added to VFP3.0b.
*
*  For more information on required elements, features, etc., please
*  refer to the ADF1.DOC that accompanies this framework.
*  
*  The .VCX files that contain definitions for 
*      oLib
*      oApp
*      oUser
*      oForms
*      oReports
*      oMenu 
*  whether the default X3FW.VCX classes or your subclasses must be in 
*  the FoxPro path at the time X3FWMAIN executes.  You have several
*  options:
*      1- set the PATH in CONFIG.FPW
*      2- execute a SET PATH in xxMAIN.PRG
*      3- technically, only the .VCX containing oApp definition needs
*         to be in the path, because if any other needed .VCXs are in
*         another path, that path can be included in the appropriate
*         record in the APPINFO table, which pathing is appended to
*         the current SET PATH in the application setup in oApp
*         
*
*  Usage:
*    See the example at the end of this .PRG 
*
*
*  lParameters
*    tcMainDatabase (O) The name of the main application database, the
*                         one containing the application info table.
*                         (The MaxTech default is to have an xx.DBC
*                         where the "xx" is the 2-char application
*                         prefix, so the main database name is
*                         identical to/synonymous with the main
*                         application database name)
*                       Defaults to space(0), in which case be sure
*                         to set icMainDatabase property in your
*                         application-object subclass. 
*     tcAppLibClass (O) The name of the class instantiated as oLib
*                       You can optionally add a comma delimiter and
*                         a .VCX name containing the class definition
*                       When oLib is instantiated, as many comma-
*                         delimited .VCX names as you add after
*                         the "|" pipe character have their classes
*                         AddObject()ed to oLib.
*                       If you pass this parameter, you MUST include
*                         at least one pipe-character-delimited .VCX
*                         name or oLib will not be created because it
*                         will have no members.
*                       The class library specified here is referred to
*                         only by indirection during setup, so you'll
*                         want to put an explicit/dummy reference in
*                         your main calling .PRG so the Project Manager
*                         will pull in the .VCX.
*                       Defaults to "cusAppLibs,X3FW|X3FWLIBS"
*        tcAppClass (O) The name of the class instantiated as oApp
*                       You can optionally add a comma delimiter and
*                         a .VCX name containing the class definition
*                       Defaults to "cusApp,X3FW"
*       tcUserClass (O) The name of the class instantiated as oUser
*                       You can optionally add a comma delimiter and
*                         a .VCX name containing the class definition
*                       Defaults to "cusUser,X3FW"
*      tcFormsClass (O) The name of the class instantiated as oForms
*                       You can optionally add a comma delimiter and
*                         a .VCX name containing the class definition
*                       Defaults to "cusForms,X3FW"
*    tcReportsClass (O) The name of the class instantiated as oReports
*                       You can optionally add a comma delimiter and
*                         a .VCX name containing the class definition
*                       Defaults to "cusReports,X3FW"
*       tcMenuClass (O) The name of the class instantiated as oMenu
*                       You can optionally add a comma delimiter and
*                         a .VCX name containing the class definition
*                       Defaults to "cusMenu,X3FW"
*          tcSplash (0) The string to be used to instantiate a splash
*                       screen.  May be any one of the following:
*                         <.BMP FileName>
*                         <.SCX FileName>
*                         <ClassName,.VCX FileName>
*                       Any passed splash screen is Release()d in
*                       oApp.Init().  Defaults to no splash screen.
*
lparameters tcMainDatabase, ;
            tcAppLibClass, ;
            tcAppClass, ;
            tcUserClass, ;
            tcFormsClass, ;
            tcReportsClass, ;
            tcMenuClass, ;
            tcSplash

set talk off
IF version(2) = 0
  *
  *  runtime
  *
  IF empty(_Screen.Icon)
    *
    *  if the calling program hasn't set an
    *  explicit _Screen.Icon, suppress the
    *  VFP FoxHead icon until any application-
    *  icon is installed by oApp
    *
    _Screen.Icon = space(0)
  ENDIF
 ELSE
  *
  *  from the Command Window
  *
  activate screen
  clear
ENDIF
IF type("tcMainDatabase") = "C" ;
     AND !empty(tcMainDatabase) 
  tcMainDatabase = upper(alltrim(tcMainDatabase)) 
 ELSE
  do TroubleGettingIn
  return
ENDIF

***************************************************
*  install any indicated Splash Screen
***************************************************
IF type("tcSplash") = "C" AND !empty(tcSplash)
  local loSplashScreen
  loSplashScreen = InstallSplashScreen(upper(alltrim(tcSplash)))
  IF type("loSplashScreen") = "O" ;
       AND !isnull(loSplashScreen)
    * splash screen installation was successful
   ELSE
    do TroubleGettingIn
    return
  ENDIF  
ENDIF


local llCheck, lcClassDefinition

***************************************************
* create the library object:
***************************************************
IF isnull(tcAppLibClass)
  *
  *  this particular app needs no library object
  *
 ELSE
  local lcLibraryVCXs
  lcLibraryVCXs = space(0)
  IF type("tcAppLibClass") = "C" AND !empty(tcAppLibClass)
    lcClassDefinition = upper(alltrim(tcAppLibClass))
    IF "|" $ lcClassDefinition
      lcLibraryVCXs     = substr(lcClassDefinition,at("|",lcClassDefinition)+1)
      lcClassDefinition = left(lcClassDefinition,at("|",lcClassDefinition)-1)
     ELSE
      *
      *  DANGER!  If you haven't passed at least one
      *           .VCX name, oLib will be created
      *           but then released because it'll
      *           have no members
      *
    ENDIF
    lcClassDefinition = ParseClassNameAndSetLibrary(lcClassDefinition)
   ELSE 
    *
    *  default/not passed
    *
    lcLibraryVCXs     = "X3FWLIBS"
    lcClassDefinition = ParseClassNameAndSetLibrary("cusAppLibs,X3FW")
  ENDIF
  IF isnull(lcClassDefinition)
    do TroubleGettingIn with .f.,"oLib"
    return
  ENDIF
  oLib = createobject(lcClassDefinition,lcLibraryVCXs)
  release lcLibraryVCXs
  IF type("oLib")="O" AND !isnull(oLib) 
   ELSE
    do TroubleGettingIn with .f.,"oLib"
    return
  ENDIF
  IF amembers(junk,oLib,2) = 0
    *
    *  no member library objects --
    *  no need to keep oLib around
    *
    release oLib
  ENDIF
  release junk
ENDIF 

***************************************************
* create the application object:
***************************************************
IF type("tcAppClass") = "C" AND !empty(tcAppClass)
  lcClassDefinition = ParseClassNameAndSetLibrary(tcAppClass)
 ELSE 
  *
  *  default/not passed
  *
  lcClassDefinition = ParseClassNameAndSetLibrary("ctrApp,X3FW")
ENDIF
IF isnull(lcClassDefinition)
  do TroubleGettingIn with .f.,"oApp"
  return
ENDIF
oApp = createobject(lcClassDefinition,tcMainDatabase) 
IF type("oApp")="O" AND !isnull(oApp) 
 ELSE
  do TroubleGettingIn with .f.,"oApp"
  return
ENDIF
IF oApp.GetPProp("ilTerminateAfterInit")
  *
  *  during oApp.Init(), a problem was
  *  encountered that was handled there,
  *  but indicates the app should be 
  *  terminated.  For example, it may
  *  have been determined that the user
  *  was attempting to fire up a 2nd
  *  session of the app but 
  *  oApp.ilAllowMultipleInstances = .f.
  *
  do TroubleGettingIn with .t.
  return
ENDIF
*
*  execute any desired AfterInstallApp() code
*
llCheck = oApp.AfterInstallApp()
IF IsThereAnyTrouble(llCheck,"oApp.AfterInstallApp")
  do ReleaseAppObjects
  return
ENDIF 

***************************************************
* create the User object:
***************************************************
IF type("tcUserClass") = "C" AND !empty(tcUserClass)
  lcClassDefinition = ParseClassNameAndSetLibrary(tcUserClass)
 ELSE 
  *
  *  default/not passed
  *
  lcClassDefinition = ParseClassNameAndSetLibrary("cusUser,X3FW")
ENDIF
IF isnull(lcClassDefinition)
  do TroubleGettingIn with .f.,"oUser"
  return
ENDIF
oUser = createobject(lcClassDefinition) 
IF type("oUser")="O" AND !isnull(oUser) 
 ELSE
  *
  * oUser object not created
  *   or  
  * something went wrong with user login form
  *
  do TroubleGettingIn with .f.,"oUser"
  return
ENDIF
IF eof(oUser.GetPProp("icUsersTableName"))
  *
  *  password login was unsuccessful
  *
  do TroubleGettingIn with .t.
  return
ENDIF
*
*  execute any desired AfterInstallUser() code
*
llCheck = oApp.AfterInstallUser()
IF IsThereAnyTrouble(llCheck,"oApp.AfterInstallUser()")
  do ReleaseAppObjects
  return
ENDIF 


***************************************************
* create the Forms manager object:
***************************************************
IF type("tcFormsClass") = "C" AND !empty(tcFormsClass)
  lcClassDefinition = ParseClassNameAndSetLibrary(tcFormsClass)
 ELSE
  *
  *  default/not passed
  *
  lcClassDefinition = ParseClassNameAndSetLibrary("cusForms,X3FW")
ENDIF
IF isnull(lcClassDefinition)
  do TroubleGettingIn with .f.,"oForms"
  return
ENDIF
oForms = createobject(lcClassDefinition)
IF type("oForms")="O" AND !isnull(oForms) 
 ELSE
  do TroubleGettingIn with .f.,"oForms"
  return
ENDIF
*
*  execute any desired AfterInstallFormsHandler() code
*
llCheck = oApp.AfterInstallFormsHandler()
IF IsThereAnyTrouble(llCheck,"oApp.AfterInstallFormsHandler()")
  do ReleaseAppObjects
  return
ENDIF 

***************************************************
* create the report catalog object:
***************************************************
IF type("tcReportsClass") = "C" AND !empty(tcReportsClass)
  lcClassDefinition = ParseClassNameAndSetLibrary(tcReportsClass)
 ELSE 
  *
  *  default/not passed
  *
  lcClassDefinition = ParseClassNameAndSetLibrary("cusReports,X3FW")
ENDIF
IF isnull(lcClassDefinition)
  do TroubleGettingIn with .f.,"oReports"
  return
ENDIF
oReports = createobject(lcClassDefinition)
IF type("oReports")="O" AND !isnull(oReports) 
 ELSE
  do TroubleGettingIn with .f.,"oReports"
  return
ENDIF
*
*  execute any desired AfterInstallReports() code
*
llCheck = oApp.AfterInstallReports()
IF IsThereAnyTrouble(llCheck,"oApp.AfterInstallReports()")
  do ReleaseAppObjects
  return
ENDIF 

***************************************************
* create the Menu object
***************************************************
IF type("tcMenuClass") = "C" AND !empty(tcMenuClass)
  lcClassDefinition = ParseClassNameAndSetLibrary(tcMenuClass)
 ELSE 
  *
  *  default/not passed
  *
  lcClassDefinition = ParseClassNameAndSetLibrary("cusMenu,X3FW")
ENDIF
IF isnull(lcClassDefinition)
  do TroubleGettingIn with .f.,"oMenu"
  return
ENDIF
oMenu = createobject(lcClassDefinition) 
IF type("oMenu")="O" AND !isnull(oMenu) 
 ELSE
  do TroubleGettingIn with .f.,"oMenu"
  return
ENDIF
*
*  execute any desired AfterInstallMenu() code
*
llCheck = oApp.AfterInstallMenu()
IF IsThereAnyTrouble(llCheck,"oApp.AfterInstallMenu()")
  do ReleaseAppObjects
  return
ENDIF 

***************************************************
*  release the local memvars used here for class instantiation 
***************************************************
release llClassProblem
release lcClassDefinition

***************************************************
*  install any specified bitmap wallpaper:
***************************************************
*
*  execute any desired InstallBitmapWallpaper() code
*
llCheck = oApp.InstallBitmapWallpaper()
IF IsThereAnyTrouble(llCheck,"oApp.InstallBitmapWallpaper()")
  do ReleaseAppObjects
  return
ENDIF 

***************************************************
*  application wait state 
***************************************************
*
*  execute final setup code to execute just
*  before READ EVENTS 
*
llCheck = oApp.BeforeReadEvents()
IF IsThereAnyTrouble(llCheck,"oApp.BeforeReadEvents()")
  do ReleaseAppObjects
  return
ENDIF 

release llCheck

oApp.ReadEvents()

***************************************************
*  application cleanup
***************************************************
do ReleaseAppObjects

return



PROCEDURE ReleaseAppObjects
*
*  release the objects created here
*  each contain cleanup code in Destroy() 
*
activate screen
clear
release oMenu
release oReports
release oForms 
release oUser
release oLib
release oApp
*
*  these are likely needed if the
*  app has to be prematurely aborted
*
close all
set library to
clear all
return



PROCEDURE TroubleGettingIn
*
*  hit the road 
*
lparameters tlNoMessage, tcDebugString, tlNoRelease
IF !tlNoMessage
  lcMessage = "Unable to set up the system.  Please report this problem."
  ?? chr(7)
  IF (type("oApp")#"O" OR isnull(oApp)) OR oApp.InProduction() ;
       OR empty(tcDebugString)  
    =messagebox(lcMessage,0+16+0,"Please Note")
   ELSE oApp.InDevelopment() 
    lcMessage = lcMessage + chr(13) + chr(13)
    IF empty(tcDebugString)
      =messagebox(lcMessage+"Developer:  SET CLASSLIB TO or instantiating oApp", ;
                  0+16+0, ;
                  "Please Note")
     ELSE
      =messagebox(lcMessage+"Developer:  "+tcDebugString, ;
                  0+16+0, ;
                  "Please Note")
    ENDIF
  ENDIF oApp.InProduction() OR empty(tcDebugString)  
ENDIF
IF !tlNoRelease
  do ReleaseAppObjects
ENDIF
return



PROCEDURE IsThereAnyTrouble
*
*  Check for trouble on executing the 
*  oApp.After...() methods
*
*  NOTE:  the oApp.After...() method needs to
*         return one of 3 values:
*         .NULL. = bail out of the app, 
*                  no additional message to the user
*            .F. = abort the app, give the user
*                  the standard TroubleGettingIn()
*                  message
*            .T. = everything's AOK
*
lparameters tlSuccessIndicator, tcDeveloperMessage
local llWeveGotTrouble
llWeveGotTrouble = isnull(tlSuccessIndicator) OR !tlSuccessIndicator
DO CASE
  CASE isnull(tlSuccessIndicator)
    * bail out of the app, no additional
    * message to the user
    do TroubleGettingIn with .t.,.f.,.t.
  CASE !tlSuccessIndicator
    * problem -- alert the user
    do TroubleGettingIn with .f.,tcDeveloperMessage,.t.
  OTHERWISE tlSuccessIndicator
    * success!
ENDCASE 
return llWeveGotTrouble




PROCEDURE ParseClassNameAndSetLibrary
*
*  take action based on the passed tcString
*  and pass back the indicated Class Name
*  
*  lParameters
*    tcString     (R) String to be parsed
*
lparameters tcString
IF type("tcString") = "C" AND !empty(tcString)
  local lcString
  lcString = upper(alltrim(tcString))
 ELSE
  return space(0)
ENDIF
local lcClassName
IF "," $ lcString
  lcClassName = left(lcString,at(",",lcString)-1)
  *
  *  also SET CLASSLIB TO whatever is after the comma
  *
  local lcClassLib
  lcClassLib = substr(lcString,at(",",lcString)+1)
  IF !empty(lcClassLib)
    local lcOnError
    lcOnError = on("ERROR")
    on error lcClassName = .NULL.
    set classlib to (lcClassLib) additive
    on error &lcOnError
  ENDIF
 ELSE
  lcClassName = lcString
ENDIF
return lcClassName


PROCEDURE InstallSplashScreen
*
*  install the indicated splash screen
*
*  NOTE: the splash screen is Release()d
*        in oApp.Init()
*
*
*  lParameters
*    tcSplashScreen (R) Splash screen to instantiate
*                       May be any one of the 
*                       following:
*                       <.BMP file name>
*                       <.SCX file name>
*                       <ClassName,.VCX file name>
*
*
lparameters tcSplashScreen
local loScreen
loScreen = .f.
DO CASE
  ***********************************
  CASE ".BMP" $ tcSplashScreen
  ***********************************
    *
    *  only a .BMP filename was passed -- use the
    *  default splash screen in the X3FW library
    *
    *  NOTE:  the following explicity SET CLASSLIB TO
    *         pulls the X3FW.VCX into the project
    *
    set classlib to x3fw
    loScreen = createobject("frmSplash")
    IF isnull(loScreen)
     ELSE
      loScreen.BackColor = _Screen.BackColor
      loScreen.imgSplash.Picture = "MTSPLASH.BMP"
      loScreen.imgSplash.Top = 0
      loScreen.imgSplash.Left = 0
      loScreen.Height = loScreen.imgSplash.Height
      loScreen.Width = loScreen.imgSplash.Width
      loScreen.AutoCenter = .t.
      loScreen.Show()
    ENDIF
  ***********************************
  CASE ".SCX" $ tcSplashScreen
  ***********************************
    *
    *  an .SCX filename was passed -- DO it
    *
    IF file(tcSplashScreen)
      do form (tcSplashScreen) name loScreen
    ENDIF
  ***********************************
  CASE "," $ tcSplashScreen
  ***********************************
    *
    *  a "class,vcxfilename" was passed, create
    *  an instance of it
    *
    local lcClassName
    lcClassName = ParseClassNameAndSetLibrary(tcSplashScreen)
    IF isnull(lcClassName)
      * bad .VCX class library
     ELSE
      loScreen = createobject(lcClassName)
      loScreen.Show()
    ENDIF
ENDCASE
return loScreen




#IF .f.

****************************************************
*
*  The following is an example of the xxMAIN.PRG
*  main calling program for an application using
*  the MaxTech X3 application framework for
*  Visual FoxPro.
*
*  If you have our Level 2 application classes and
*  the MT example application, see MTMAIN.PRG for
*  a more detailed example.
*
****************************************************

*
*  xxMAIN.PRG
*  Example of a main calling program for a standard
*  MaxTech application in the X3 application
*  framework
*
clear all
clear all
do x3fwmain with "XX",.f.,"ctrXXApplication"
return


PROCEDURE pmFakeOut
*
*  Since we generally SET CLASSLIB TO, call 
*  .SCX-based forms, menus, etc. via indirection,
*  we place direct calls to them here to force the
*  Project Manager to pull them into the .PJX
*  project.  Note that this procedure is never
*  called in the application.
*
return


*
*  if any of the application-level classes need
*  one simple level of subclassing to override, 
*  add, or modify minor items, this might be a
*  good place to put the subclasses
*
DEFINE CLASS ctrXXApplication AS ctrApp

  PROTECTED PROCEDURE SetupCustom
    set status bar on
    set clock status
  ENDPROC

ENDDEFINE
 
#ENDIF .f. 